﻿print("------------ Start Output Data Engineering ------------")
# --------------------------------- Output Data Engineering ---------------------------------
# -------------------- Libraries --------------------
import os
import pandas as pd
# --------------------------------- Collect Predictions ---------------------------------
output_data_dir = './Output_Data/'
results_dir = './Results/'
run_directories = os.listdir(output_data_dir)
all_predictions_df = pd.DataFrame()
evolution_df = pd.DataFrame()
for rd in run_directories:
    try:
        pred_df = pd.read_csv(output_data_dir+rd+'/'+'predictions_df.csv')
        pred_df['run_directory'] = rd
    except:
        pass
    try:
        prop_df = pd.read_csv(output_data_dir+rd+'/'+'properties_df.csv')
        prop_df['run_directory'] = rd
    except:
        pass
    all_predictions_df = all_predictions_df.append(pred_df)
    evolution_df = evolution_df.append(prop_df)
# --------------------------------- Create Performance---------------------------------
actuals_df = pd.read_csv(results_dir+'forecast_job_results_table_df.csv')[['timestamp','target']].drop_duplicates()
performance_df = all_predictions_df.drop(columns='target').merge(actuals_df,on='timestamp',how='left')
performance_df.to_csv(results_dir+'performance_df.csv',index=False)
# --------------------------------- Create Evolution ---------------------------------
evolution_df['run_datetime'] = pd.to_datetime(evolution_df['run_directory'], format='%Y_%m_%d_%H_%M_%S')
evolution_df.to_csv(results_dir+'evolution_df.csv',index=False)
# --------------------------------- END OF SCRIPT ---------------------------------
print("------------ End Output Data Engineering ------------")
